## ros-iron-swri-transform-util 3.6.1

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.10)
project(swri_transform_util)

set(CMAKE_CXX_STANDARD 14)

find_package(ament_cmake REQUIRED)
find_package(ament_cmake_python REQUIRED)
find_package(diagnostic_msgs REQUIRED)
find_package(diagnostic_updater REQUIRED)
find_package(geographic_msgs REQUIRED)
find_package(geometry_msgs REQUIRED)
find_package(gps_msgs REQUIRED)
find_package(marti_nav_msgs REQUIRED)
find_package(rcl_interfaces REQUIRED)
find_package(rclcpp REQUIRED)
find_package(rclcpp_components REQUIRED)
find_package(sensor_msgs REQUIRED)
find_package(swri_math_util REQUIRED)
find_package(swri_roscpp REQUIRED)
find_package(tf2 REQUIRED)
find_package(tf2_ros REQUIRED)

# tf2_geometry_msgs 0.12.1 broke API compatibility, so check which version
# we need to use
find_package(tf2_geometry_msgs REQUIRED)
if("${tf2_geometry_msgs_VERSION}" VERSION_GREATER "0.12.0")
  set(USE_NEW_TF2_TOMSG 1)
else()
  set(USE_NEW_TF2_TOMSG 0)
endif()

find_package(yaml-cpp REQUIRED)
find_package(OpenCV REQUIRED calib3d core highgui imgproc video)
find_package(Boost REQUIRED filesystem thread)

find_package(PkgConfig REQUIRED)
pkg_check_modules(PROJ proj)
if(NOT "${PROJ_FOUND}")
  set(PROJ_INCLUDE_DIRS /usr/include)
  set(PROJ_LIBRARY_DIRS /usr/lib)
  find_library(PROJ_LIBRARIES proj
    HINTS ${PROJ_LIB_DIRS}
  )
endif()

add_library(${PROJECT_NAME} SHARED
  src/georeference.cpp
  src/local_xy_util.cpp
  src/utm_util.cpp
  src/transform.cpp
  src/transformer.cpp
  src/transform_manager.cpp
  src/transform_util.cpp
  src/tf2_util.cpp
  src/utm_transformer.cpp
  src/wgs84_transformer.cpp)
target_include_directories(${PROJECT_NAME}
  PUBLIC
  $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>
  $<INSTALL_INTERFACE:include>
)
target_include_directories(${PROJECT_NAME}
  SYSTEM
  INTERFACE
  ${PROJ_INCLUDE_DIRS}
)
set_property(TARGET ${PROJECT_NAME}
  PROPERTY POSITION_INDEPENDENT_CODE ON)
target_compile_definitions(${PROJECT_NAME}
  PUBLIC
    USE_NEW_TF2_TOMSG=${USE_NEW_TF2_TOMSG}
)

target_link_libraries(${PROJECT_NAME}
  PUBLIC
  Boost::boost
  Boost::filesystem
  Boost::thread
  opencv_calib3d
  opencv_core
  opencv_highgui
  opencv_imgproc
  opencv_video
  ${PROJ_LIBRARIES}
  yaml-cpp
)
ament_target_dependencies(${PROJECT_NAME}
  PUBLIC
  diagnostic_msgs
  diagnostic_updater
  geographic_msgs
  geometry_msgs
  gps_msgs
  rclcpp
  sensor_msgs
  swri_math_util
  swri_roscpp
  tf2
  tf2_geometry_msgs
  tf2_ros
)

add_library(${PROJECT_NAME}_nodes SHARED
  src/nodes/dynamic_transform_publisher.cpp
  src/nodes/gps_transform_publisher.cpp
  src/nodes/obstacle_transformer.cpp
)
target_include_directories(${PROJECT_NAME}_nodes
  PUBLIC
  $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>
  $<INSTALL_INTERFACE:include>
)
target_include_directories(${PROJECT_NAME}_nodes
  SYSTEM
  INTERFACE
  ${PROJ_INCLUDE_DIRS}
)

target_compile_definitions(${PROJECT_NAME}
  PUBLIC "${TF_UTIL_DEFINITIONS}"
  )
target_compile_definitions(${PROJECT_NAME}_nodes
  PRIVATE "${TF_UTIL_DEFINITIONS}"
  )

target_compile_definitions(${PROJECT_NAME}_nodes
  PRIVATE "COMPOSITION_BUILDING_DLL")
rclcpp_components_register_nodes(${PROJECT_NAME}_nodes "swri_transform_util::DynamicTransformPublisher")
rclcpp_components_register_nodes(${PROJECT_NAME}_nodes "swri_transform_util::GpsTransformPublisher")
rclcpp_components_register_nodes(${PROJECT_NAME}_nodes "swri_transform_util::ObstacleTransformer")
target_link_libraries(${PROJECT_NAME}_nodes ${PROJECT_NAME})
ament_target_dependencies(${PROJECT_NAME}_nodes
  marti_nav_msgs
  rcl_interfaces
  swri_roscpp
  rclcpp_components
)

add_executable(lat_lon_tf_echo src/nodes/lat_lon_tf_echo.cpp)
target_include_directories(lat_lon_tf_echo
  PUBLIC
  $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>
  $<INSTALL_INTERFACE:include>
)
target_include_directories(lat_lon_tf_echo
  SYSTEM
  INTERFACE
  ${PROJ_INCLUDE_DIRS}
)

target_link_libraries(lat_lon_tf_echo ${PROJECT_NAME})

# TODO pjr Convert unit tests
# if(BUILD_TESTING)
#   find_package(ament_cmake_gtest REQUIRED)
# 
#  add_rostest_gtest(test_local_xy_util launch/local_xy_util.test test/test_local_xy_util.cpp)
#  target_link_libraries(test_local_xy_util ${PROJECT_NAME})
#
#  add_rostest_gtest(test_utm_util launch/utm_util.test test/test_utm_util.cpp)
#  target_link_libraries(test_utm_util ${PROJECT_NAME})
#
#  add_rostest_gtest(test_transform_manager launch/transform_manager.test test/test_transform_manager.cpp)
#  target_link_libraries(test_transform_manager ${PROJECT_NAME})
#
#  add_rostest_gtest(test_georeference launch/georeference.test test/test_georeference.cpp)
#  target_link_libraries(test_georeference ${PROJECT_NAME})
#
#  add_rostest_gtest(test_transform_util launch/transform_util.test test/test_transform_util.cpp)
#  target_link_libraries(test_transform_util ${PROJECT_NAME})
#
#  add_rostest(test/initialize_invalid_gps.test)
#  add_rostest(test/initialize_invalid_navsat.test)
#  add_rostest(test/initialize_origin_auto_custom.test)
#  add_rostest(test/initialize_origin_auto_gps.test)
#  add_rostest(test/initialize_origin_auto_navsat.test)
#  add_rostest(test/initialize_origin_manual.test)
# endif()

install(DIRECTORY include/
  DESTINATION include
)

install(DIRECTORY launch
  DESTINATION share/${PROJECT_NAME}/
)

install(TARGETS
  ${PROJECT_NAME}
  ${PROJECT_NAME}_nodes
  lat_lon_tf_echo
  RUNTIME DESTINATION bin
  LIBRARY DESTINATION lib
  ARCHIVE DESTINATION lib
)

### Install Python Nodes/Scripts ###
install(PROGRAMS nodes/initialize_origin.py
  DESTINATION lib/${PROJECT_NAME}
)

ament_python_install_package(${PROJECT_NAME})
ament_export_definitions("${TF_UTIL_DEFINITIONS}")
ament_export_dependencies(
  ament_cmake
  geographic_msgs
  gps_msgs
  tf2_geometry_msgs
)
ament_export_include_directories(include)
ament_export_libraries(${PROJECT_NAME}
  ${PROJ_LIBRARIES}
)
ament_package()

=== debian/changelog ===
ros-iron-swri-transform-util (3.6.1-1jammy) jammy; urgency=high

  * Fixing Buildfarm Issues (#716 <https://github.com/swri-robotics/marti_common/issues/716>)
    * Cleaning up code to fix build farm errors
  * Contributors: David Anthony

 -- P. J. Reed <preed@swri.org>  Mon, 11 Sep 2023 05:00:00 -0000

ros-iron-swri-transform-util (3.6.0-1jammy) jammy; urgency=high

  * Rolling updates (#715 <https://github.com/swri-robotics/marti_common/issues/715>)
    - Updating code for Rolling.
    - Removing conditional compilation code related to EOL distributions.
  * Contributors: David Anthony

 -- P. J. Reed <preed@swri.org>  Tue, 22 Aug 2023 05:00:00 -0000

ros-iron-swri-transform-util (3.5.4-1jammy) jammy; urgency=high



 -- P. J. Reed <preed@swri.org>  Mon, 14 Aug 2023 05:00:00 -0000

ros-iron-swri-transform-util (3.5.3-1jammy) jammy; urgency=high

  * Fixing build error in Iron (#709 <https://github.com/swri-robotics/marti_common/issues/709>)
  * Contributors: David Anthony

 -- P. J. Reed <preed@swri.org>  Wed, 07 Jun 2023 05:00:00 -0000

ros-iron-swri-transform-util (3.5.2-1jammy) jammy; urgency=high

  * Fix dependencies (#704 <https://github.com/danthony06/marti_common/issues/704>)
    * Fixing build process so dependencies are correctly exported.
  * Make timeout 0.1 seconds instead of 0 (#694 <https://github.com/danthony06/marti_common/issues/694>)
  * Set origin (#696 <https://github.com/danthony06/marti_common/issues/696>)
    * Improved origin initialization
    ---------
    Co-authored-by: tcappellari <mailto:tiffany.cappellari@swri.org>
  * Contributors: David Anthony, Tiffany Cappellari, Veronica Knisley

 -- P. J. Reed <preed@swri.org>  Tue, 30 May 2023 05:00:00 -0000

ros-iron-swri-transform-util (3.5.1-1jammy) jammy; urgency=high



 -- P. J. Reed <preed@swri.org>  Tue, 29 Nov 2022 06:00:00 -0000

ros-iron-swri-transform-util (3.5.0-1jammy) jammy; urgency=high

  * Fix ament exports (#693 <https://github.com/swri-robotics/marti_common/issues/693>)
    * Fix ament exports
  * Contributors: P. J. Reed

 -- P. J. Reed <preed@swri.org>  Tue, 11 Oct 2022 05:00:00 -0000

ros-iron-swri-transform-util (3.4.2-1jammy) jammy; urgency=high

  * Add Humble Support (#691 <https://github.com/swri-robotics/marti_common/issues/691>)
    * Adding Humble support based on @shrijitsingh99 PR in https://github.com/swri-robotics/marti_common/pull/685
  * Contributors: David Anthony, Shrijit Singh

 -- P. J. Reed <preed@swri.org>  Mon, 10 Oct 2022 05:00:00 -0000

ros-iron-swri-transform-util (3.3.2-1jammy) jammy; urgency=high



 -- P. J. Reed <preed@swri.org>  Tue, 24 Nov 2020 06:00:00 -0000

ros-iron-swri-transform-util (3.3.1-1jammy) jammy; urgency=high

  * Fix bad conversion when 90 degree yaw specified (#599 <https://github.com/swri-robotics/marti_common/issues/599>)
  * Contributors: Alex Youngs

 -- P. J. Reed <preed@swri.org>  Wed, 19 Aug 2020 05:00:00 -0000

ros-iron-swri-transform-util (3.3.0-1jammy) jammy; urgency=high

  * Add python wgs84 transformer ros2 (#596 <https://github.com/swri-robotics/marti_common/issues/596>)
  * Improve object transformer to take into account the pose of the object (#589 <https://github.com/swri-robotics/marti_common/issues/589>) (#591 <https://github.com/swri-robotics/marti_common/issues/591>)
  * Add GitHub Actions for CI (ROS2) (#586 <https://github.com/swri-robotics/marti_common/issues/586>)
  * Contributors: P. J. Reed, Alex Youngs, Matthew Bries

 -- P. J. Reed <preed@swri.org>  Wed, 15 Jul 2020 05:00:00 -0000

ros-iron-swri-transform-util (3.2.1-1jammy) jammy; urgency=high

  * ROS Foxy support (#582 <https://github.com/swri-robotics/marti_common/issues/582>)
  * Contributors: P. J. Reed

 -- P. J. Reed <preed@swri.org>  Wed, 10 Jun 2020 05:00:00 -0000

ros-iron-swri-transform-util (3.2.0-1jammy) jammy; urgency=high



 -- P. J. Reed <preed@swri.org>  Wed, 13 May 2020 05:00:00 -0000

ros-iron-swri-transform-util (3.1.0-1jammy) jammy; urgency=high

  * Fix swri_transform_util::TransformManager initialization issues
  * Implement initialize_origin.py in ROS Eloquent
  * Contributors: P. J. Reed

 -- P. J. Reed <preed@swri.org>  Mon, 30 Mar 2020 05:00:00 -0000

ros-iron-swri-transform-util (3.0.5-1jammy) jammy; urgency=high

  * Also add NavSatFix support to swri_transform_util::LocalXyUtil (#569 <https://github.com/swri-robotics/marti_common/issues/569>)
  * Contributors: P. J. Reed

 -- P. J. Reed <preed@swri.org>  Tue, 10 Mar 2020 05:00:00 -0000

ros-iron-swri-transform-util (3.0.4-1jammy) jammy; urgency=high

  * ROS 2 Eloquent compatibility (#568 <https://github.com/swri-robotics/marti_common/issues/568>)
  * Replace boost::array with std::array (#567 <https://github.com/swri-robotics/marti_common/issues/567>)
  * Fix a crash that happened due to an initialization error (#566 <https://github.com/swri-robotics/marti_common/issues/566>)
  * Fix TransformManager so it works in ROS2 (#565 <https://github.com/swri-robotics/marti_common/issues/565>)
  * Port ObstacleTransformer node to ROS2 (#559 <https://github.com/swri-robotics/marti_common/issues/559>)
  * Remove "nodelets" directory (#558 <https://github.com/swri-robotics/marti_common/issues/558>)
  * Contributors: P. J. Reed

 -- P. J. Reed <preed@swri.org>  Thu, 05 Mar 2020 06:00:00 -0000

ros-iron-swri-transform-util (3.0.3-1jammy) jammy; urgency=high



 -- P. J. Reed <preed@swri.org>  Mon, 11 Nov 2019 06:00:00 -0000

ros-iron-swri-transform-util (3.0.2-1jammy) jammy; urgency=high

  * Comment out ament_cmake_gtest (#555 <https://github.com/pjreed/marti_common/issues/555>)
  * Contributors: P. J. Reed

 -- P. J. Reed <preed@swri.org>  Mon, 11 Nov 2019 06:00:00 -0000

ros-iron-swri-transform-util (3.0.1-1jammy) jammy; urgency=high

  * Add missing dependency on Boost::thread to swri_transform_util (#554 <https://github.com/pjreed/marti_common/issues/554>)
  * Contributors: P. J. Reed

 -- P. J. Reed <preed@swri.org>  Mon, 11 Nov 2019 06:00:00 -0000



=== debian/control ===
Source: ros-iron-swri-transform-util
Section: misc
Priority: optional
Maintainer: P. J. Reed <preed@swri.org>
Build-Depends: debhelper (>= 9.0.0), libboost-all-dev, libgeos-dev, libproj-dev, libyaml-cpp-dev, pkg-config, ros-iron-ament-cmake, ros-iron-ament-cmake-python, ros-iron-cv-bridge, ros-iron-diagnostic-msgs, ros-iron-diagnostic-updater, ros-iron-geographic-msgs, ros-iron-geometry-msgs, ros-iron-gps-msgs, ros-iron-marti-nav-msgs, ros-iron-rcl-interfaces, ros-iron-rclcpp, ros-iron-rclcpp-components, ros-iron-rclpy, ros-iron-sensor-msgs, ros-iron-swri-math-util, ros-iron-swri-roscpp, ros-iron-tf2, ros-iron-tf2-geometry-msgs, ros-iron-tf2-ros, ros-iron-ros-workspace
Homepage: https://github.com/swri-robotics/marti_common
Standards-Version: 3.9.2

Package: ros-iron-swri-transform-util
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libboost-all-dev, libgeos-dev, libproj-dev, libyaml-cpp-dev, python3-numpy, ros-iron-cv-bridge, ros-iron-diagnostic-msgs, ros-iron-diagnostic-updater, ros-iron-geographic-msgs, ros-iron-geometry-msgs, ros-iron-gps-msgs, ros-iron-marti-nav-msgs, ros-iron-rcl-interfaces, ros-iron-rclcpp, ros-iron-rclcpp-components, ros-iron-rclpy, ros-iron-sensor-msgs, ros-iron-swri-math-util, ros-iron-swri-roscpp, ros-iron-tf2, ros-iron-tf2-geometry-msgs, ros-iron-tf2-ros, ros-iron-ros-workspace
Description: The swri_transform_util package contains utility functions and classes for transforming between coordinate frames.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/iron/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG
ifneq ($(filter nocheck,$(DEB_BUILD_OPTIONS)),)
	BUILD_TESTING_ARG=-DBUILD_TESTING=OFF
endif

DEB_HOST_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)

%:
	dh $@ -v --buildsystem=cmake --builddirectory=.obj-$(DEB_HOST_GNU_TYPE)

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/iron/setup.sh" ]; then . "/opt/ros/iron/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/iron" \
		-DAMENT_PREFIX_PATH="/opt/ros/iron" \
		-DCMAKE_PREFIX_PATH="/opt/ros/iron" \
		$(BUILD_TESTING_ARG)

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/iron/setup.sh" ]; then . "/opt/ros/iron/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/iron/setup.sh" ]; then . "/opt/ros/iron/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/iron/setup.sh" ]; then . "/opt/ros/iron/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-iron-swri-transform-util//opt/ros/iron/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/iron/setup.sh" ]; then . "/opt/ros/iron/setup.sh"; fi && \
	dh_auto_install
